#! /usr/bin/env python

import sys
import testui
from PyQt4 import QtGui, QtCore
from PyKDE4 import kdeui, kdecore

class Preferences(kdeui.KConfigSkeleton):
    def __init__(self):
        kdeui.KConfigSkeleton.__init__(self)
        self.setCurrentGroup('General')
        self._my_option_item = self.addItemBool('MyOption', False, False)
        self.readConfig()

    def MyOption(self):
        return self._my_option_item.property().toBool()

##

class PreferencesPage(QtGui.QWidget, testui.Ui_Dialog):
    def __init__(self, parent=None):
        QtGui.QWidget.__init__(self, parent)
        self.setupUi(self)

##

class PreferencesDialog(kdeui.KConfigDialog):
    def __init__(self, parent, name, preferences):
        kdeui.KConfigDialog.__init__(self, parent, name, preferences)
        self.page = PreferencesPage(self)
        self.addPage(self.page, 'General')

##

class MainWindow(kdeui.KMainWindow):
    def __init__ (self, *args):
        kdeui.KMainWindow.__init__(self, *args)
        self.widget = QtGui.QWidget(self)
        self.line = QtGui.QLineEdit(self.widget)
        self.button = QtGui.QPushButton('Preferences', self.widget)
        self.preferences = Preferences()

        layout = QtGui.QVBoxLayout()
        layout.addWidget(self.line)
        layout.addWidget(self.button)
        self.widget.setLayout(layout)
        self.setCentralWidget(self.widget)

        self.slot_settings_changed() # initial value

        self.connect(self.button, QtCore.SIGNAL('clicked (bool)'),
                self.slot_preferences)

    def slot_preferences(self):
        if kdeui.KConfigDialog.showDialog('preferences dialog'):
            return
        else:
            dialog = PreferencesDialog(self, 'preferences dialog', self.preferences)
            self.connect(dialog, QtCore.SIGNAL('settingsChanged(const QString &)'),
                    self.slot_settings_changed)
            dialog.show()

    def slot_settings_changed(self):
        print 'applying preferences, MyOption =', self.preferences.MyOption()
        self.line.setText(str(self.preferences.MyOption()))

def main():
    kdecore.KCmdLineArgs.init(sys.argv, 'test', '', kdecore.ki18n('test'), '1.0')
    application = kdeui.KApplication()
    main_window = MainWindow()
    main_window.show()
    application.exec_()

if __name__ == '__main__':
    main()

